#!/usr/bin/perl

#-- bermittlungsparameter einlesen
sub parse_form_data {

    local (*FORM_DATA) = @_;
    local ($request_method, $query_string, @key_value_pairs,
           $key_value, $key, $value);

	#-- Einlesen der bermittlungsmethode (Get, Post)
	$request_method = $ENV{'REQUEST_METHOD'};

	#-- Einlesen der bermittlungsparameter
    if ($request_method eq "GET") {
        $query_string = $ENV{'QUERY_STRING'};
    } elsif ($request_method eq "POST") {
        read (STDIN, $query_string, $ENV{'CONTENT_LENGTH'});
    } else {
        &return_error (500, "Server Error", "Server uses unsupported method");
    }
	
	#-- Parameterstring in Einzelparameter zerlegen
    @key_value_pairs = split (/&/, $query_string);

	#-- Einzelparameter in Hash aufbereiten
    foreach $key_value (@key_value_pairs) {
        ($key, $value) = split (/=/, $key_value);
        $value =~ tr/+/ /;
        $value =~ s/%([\dA-Fa-f][\dA-Fa-f])/pack ("C", hex ($1))/eg;

        if (defined($FORM_DATA{$key})) {
            $FORM_DATA{$key} = join ("\0", $FORM_DATA{$key}, $value);
        } else {
            $FORM_DATA{$key} = $value;
        }
    }
}


#-- Errormeldung als HTML-File ausgeben
sub return_error {
    local ($status, $keyword, $message) = @_;

    print "Content-type: text/html", "\n";
    print "Status: ", $status, " ", $keyword, "\n\n";

    print <<End_of_Error;

<title>CGI Program - Unexpected Error</title>
<h1>$keyword</h1>
<hr>$message</hr>
Please contact $webmaster for more information.

End_of_Error

    exit(1);
}

1;